package com.logicbig.example;

import static com.logicbig.example.RegexUtil.test;

public class LookBehindExample {

    public static void main(String[] args) {

        //positive lookbehind before the match
        test("(?<=[0-9])[a-z]", "a9 7c 4t zz");
        test("(?<=[0-9]{3,})[a-z]", "a9 447c 455447c 44t zz");
        test("(?<=[a-z][0-9])[a-z]", "64a 5t rr3 a6f");
        test("(?<=, )[a-z]+", "bat, cat, dog, fox");
        test("(?<=http://)\\S+", "The link is http://www.example.com");
        test("(?<=USD\\s)\\d+", "USD 500, EUR 1000, JPY 50000");
        test("(?<=1\\s)[a-z]", "1z 1b e4 2c 1 e");
        test("(?<=<h1>)[^<>]+(?=</h1>)", "<h1>Regex examples</h1><h1>Another one</h1>");
        test("(?<=<h1>(?=[^<>]+</h1>))[^<>]+", "<h1>Regex examples</h1>");
        test("(?<=\\bover[a-z]{0,30})[a-z]*", "overall overfill overheat covering");

        //positive lookbehind after the match
        test("[a-z](?<=[0-9][a-z])", "a9 7c 4t zz");
        test("[a-z](?<=[a-z][0-9][a-z])", "a9 a7 4t zz5t zz");
        test("\\d+(?<=\\$[0-9]{1,3})", "$6 $100 40");
        test("[^\\d](?<=.*)", "a9 7c 4t zz");
        test("[a-z](?<=s)", "ages mix uses woes");
        test("[a-z]+(?<=s)", "ages mix uses woes");
        test("[a-z]+?(?<=s)", "ages mix uses woes");
        test("[a-z]*ton[a-z]*(?<=[a-z]*ish)", "astonish stonefish accomplish");
        test("\\d+ \\w+(?<=\\d+ (thousand|million))", "70 million, 12 thousand, 33 hundred");
        test("\\d(?<=s\\d)", "s23e s57e s876e");
        test("\\d+(?=e)", "ssdfe s57e s876e");


        // negative lookbehind before the match
        test("(?<![0-9])[a-z]", "a9 7c 4t zz");
        test("(?<![0-9]{3,})[a-z]", "a9 447c 455447c 44t zz");
        test("(?<!b)(?<!d)(?![0-9])[a-z]", "abcde4fgh5ijk");
        test("(?<![ad0-9])[a-z]", "abcde4fgh5ijk");
        test("(?<!\\s)\\b[a-z]+", "food, stand,boss,eyed funny");
        test("\\b[a-z]+(?=d\\b)", "food, stand,boss,eyed funny");
        test("(?<!\\s)\\b[a-z]+(?=d\\b)", "food, stand,boss,eyed funny");
        test("(?<!\\s(?=[a-z]+d\\b))\\b[a-z]+", "food, stand,boss,eyed, stain, funny");


        //negative lookbehind after the match
        test("[a-z](?<![0-9][a-z])", "a9 7c 4t zz");
        test("\\d+(?<!\\$[0-9]{1,3})", "$6 $100 40");
        test("\\w(?<![0-9])", "a9 7c 4t zz");
        test("\\b[a-z]+(?=d\\b(?<!\\s[a-z]{1,30}))", "food, stand,boss,eyed funny");
    }
}